*+--------------------------------------------------------------------
*+
*+ Source Module => c:\hmg.3.4.4\0\MEMVAR\\STATIC.PRG
*+
*+    Copyright(C) 1983-2020 by Auge & Ohr
*+
*+    Functions: Function main()
*+               Procedure WinCheck()
*+               Function FullRelease()
*+               Function saveVars()
*+               Function restvars()
*+               Function fillvars()
*+               Function SelectAll()
*+
*+    Reformatted by Click! 2.05.30 on Feb-14-2020 at  4:11 pm
*+
*+--------------------------------------------------------------------

#include "HMG.CH"

STATIC aVars := {}

*+--------------------------------------------------------------------
*+
*+    Function main()
*+
*+--------------------------------------------------------------------
*+
FUNCTION main()

   AADD( aVars, { "CHECK1", .T. } )
   AADD( aVars, { "CHECK2", .T. } )
   AADD( aVars, { "CHECK3", .T. } )
   AADD( aVars, { "Sel/Unsel", .T. } )

   DEFINE WINDOW TESTSTAT MAIN AT 20, 20 WIDTH 800 HEIGHT 600
      DEFINE BUTTON Button_Test
         ROW 290
         COL 350
         WIDTH 100
         HEIGHT 100
         ACTION WinCheck()
         CAPTION "Test"
      END BUTTON
   END WINDOW

   CENTER WINDOW TESTSTAT
   ACTIVATE WINDOW TESTSTAT

   FullRelease()
RETURN

*+--------------------------------------------------------------------
*+
*+    Procedure WinCheck()
*+
*+    Called from ( static.prg )   1 - function main()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE WinCheck()

   IF IsWindowDefined( TESTMEMVAR )
      DoMethod( "TESTMEMVAR", "show" )
   ELSE

      DEFINE WINDOW TESTMEMVAR AT 20, 20 WIDTH 200 HEIGHT 200

         DEFINE CHECKBOX checkbox_0
            ROW 10
            COL 30
            WIDTH 120
            HEIGHT 20
            VALUE .t.
            CAPTION "Select/Unselect All"
            ONCHANGE SelectAll()
         END CHECKBOX

         DEFINE CHECKBOX checkbox_1
            ROW 30
            COL 30
            WIDTH 120
            HEIGHT 20
            VALUE .t.
            CAPTION "Check 1"
         END CHECKBOX

         DEFINE CHECKBOX checkbox_2
            ROW 50
            COL 30
            WIDTH 120
            HEIGHT 20
            VALUE .t.
            CAPTION "Check 2"
         END CHECKBOX

         DEFINE CHECKBOX checkbox_3
            ROW 70
            COL 30
            WIDTH 120
            HEIGHT 20
            VALUE .t.
            CAPTION "Check 3"
         END CHECKBOX

         DEFINE BUTTON button_1
            ROW 100
            COL 30
            WIDTH 120
            HEIGHT 30
            CAPTION "SAVE && EXIT"
            ACTION saveVars()
            PICTURE "save"
            PICTALIGNMENT LEFT
         END BUTTON
      END WINDOW

      RESTVARS()

      CENTER WINDOW TESTMEMVAR
      ACTIVATE WINDOW TESTMEMVAR

   ENDIF

RETURN

*+--------------------------------------------------------------------
*+
*+    Function FullRelease()
*+
*+    Called from ( static.prg )   1 - function main()
*+
*+--------------------------------------------------------------------
*+
FUNCTION FullRelease()

   TESTMEMVAR.release
RETURN

*+--------------------------------------------------------------------
*+
*+    Function saveVars()
*+
*+    Called from ( static.prg )   1 - procedure wincheck()
*+                ( testmemvar.prg )   1 - function main()
*+
*+--------------------------------------------------------------------
*+
FUNCTION saveVars()

   fillvars()
   thiswindow.hide()
RETURN nil

*+--------------------------------------------------------------------
*+
*+    Function restvars()
*+
*+    Called from ( static.prg )   1 - procedure wincheck()
*+                ( testmemvar.prg )   1 - function main()
*+
*+--------------------------------------------------------------------
*+
FUNCTION restvars()

   TESTMEMVAR.checkBOX_1.value := aVars[ 1, 2 ]
   TESTMEMVAR.checkBOX_2.value := aVars[ 2, 2 ]
   TESTMEMVAR.checkBOX_3.value := aVars[ 3, 2 ]
   TESTMEMVAR.checkBOX_0.value := aVars[ 4, 2 ]
RETURN nil

*+--------------------------------------------------------------------
*+
*+    Function fillvars()
*+
*+    Called from ( static.prg )   1 - function savevars()
*+                ( testmemvar.prg )   1 - function savevars()
*+
*+--------------------------------------------------------------------
*+
FUNCTION fillvars()

   aVars[ 1, 1 ] := "CHECK1"
   aVars[ 2, 1 ] := "CHECK2"
   aVars[ 3, 1 ] := "CHECK3"
   aVars[ 4, 1 ] := "Sel/Unsel"
   aVars[ 1, 2 ] := testmemvar.checkbox_1.value
   aVars[ 2, 2 ] := testmemvar.checkbox_2.value
   aVars[ 3, 2 ] := testmemvar.checkbox_3.value
   aVars[ 4, 2 ] := testmemvar.checkbox_0.value
RETURN

*+--------------------------------------------------------------------
*+
*+    Function SelectAll()
*+
*+    Called from ( static.prg )   1 - procedure wincheck()
*+                ( testmemvar.prg )   1 - function main()
*+
*+--------------------------------------------------------------------
*+
FUNCTION SelectAll()

   IF testmemvar.checkbox_0.value == .t.
      testmemvar.checkbox_1.value := .t.
      testmemvar.checkbox_2.value := .t.
      testmemvar.checkbox_3.value := .t.
      FOR i = 1 TO 3
         aVars[ i, 2 ] := .t.
      NEXT
   ELSEIF testmemvar.checkbox_0.value == .f.
      testmemvar.checkbox_1.value := .f.
      testmemvar.checkbox_2.value := .f.
      testmemvar.checkbox_3.value := .f.
      FOR i = 1 TO 3
         aVars[ i, 2 ] := .f.
      NEXT
   ENDIF
RETURN nil

*+ EOF: STATIC.PRG
